#if !defined(_MTF_)
#define _MTF

//TODO : ueberall short int unsigned ???  (kohaerenter)

#include <stdio.h>
#include <io.h>
#include <fcntl.h>




class MTF
{
	public :
		MTF(void){};
//		int	MTF_Encode(char *f1 , char*f2);
//		int	MTF_Decode(char *f1 , char*f2);
		int	MTF_Encode(FILE *fin , FILE *fout);
		int	MTF_Decode(FILE *fin , FILE *fout);
};




//#################################################################
//MTF::MTF_Encode(char *f1 , char *f2)
int	MTF::MTF_Encode(FILE *fin , FILE *fout)
{
//	freopen(f1 , "rb" , stdin);
//	freopen(f2 , "wb" , stdout);

	unsigned char order[ 256 ];
	int i;
	for (i=0; i<256; i++)
		order[i] = (unsigned char)i;
	int c;
	while ( (c=getc(fin)) >= 0 )
	{
		//Zeichen suchen und ausgeben
		for (i=0; i<256; i++)
			if (order[i] == (c & 0xff))
				break;

		putc((char)i , fout);

		//und das array weiterruecken
		for (int j=i; j>0; j--)
			order[j] = order[j-1];
		order[0] = (unsigned char)c;
	}

	return 1;
}


//#################################################################
int	MTF::MTF_Decode(FILE *fin , FILE *fout)
{
//	freopen(f1 , "rb" , stdin);
//	freopen(f2 , "wb" , stdout);

	unsigned char order[256];
	int i , c;
	for (i=0; i<256; i++)
		order[i] = (unsigned char)i;
	while ( (i=getc(fin)) >= 0 )
	{
		//Zeichen suchen
		putc(order[i] , fout);
		c = order[i];

		//und das array weiterruecken
		int j;
		for (j=i; j>0; j--)
			order[j] = order[j-1];
		order[0] = (unsigned char)c;
	}

	return 1;
}





#endif