#if !defined(_RLE_)
#define _RLE_



#include <stdio.h>
#include <io.h>
#include <fcntl.h>



class RLE
{
	public :
		RLE(void){};
//		int	RLE_Encode(char *f1 , char *f2);
//		int	RLE_Decode(char *f1 , char *f2);
		int	RLE_Encode(FILE *fin , FILE *fout);
		int	RLE_Decode(FILE *fin , FILE *fout);
};


//##################################################################
//int RLE::RLE_Encode(char *f1 , char *f2)
int	RLE::RLE_Encode(FILE *fin , FILE *fout)
{
//	freopen(f1 , "rb" , stdin);
//	freopen(f2 , "wb" , stdout);

	int last = 0;
	int c;
	while ( (c=getc(fin)) >= 0 )
	{
		putc((char)c , fout);
		if (c == last)
		{
			int count = 0;
			while ( (count < 255) && ((c=getc(fin)) >= 0) )
			{
				if (c == last)
					count++;
				else
					break;
			}

		putc((char)count , fout);

		if ( (count != 255) && (c >= 0) )
			putc( (char) c, fout );
		}

		last = c;
	}

	return 1;
}


//##################################################################
//int	RLE::RLE_Decode(char *f1 , char *f2)
int	RLE::RLE_Decode(FILE *fin , FILE *fout)
{
//	freopen(f1 , "rb" , stdin);
//	freopen(f2 , "wb" , stdout);

	int last = 0;
	int c , count;

	while ((c=getc(fin)) >= 0)
	{
		putc((char)c , fout);
		if (c == last)
		{
			count = getc(fin);
			while (count-- > 0)
				putc((char)c , fout);
		}
		
		last = c;
	}
	
	return 1;
}



#endif